local origin = {x = 400, y = 16}
local vertices = {0, 190, 125, 0, 190, 180}

function formatVertices(myVertices)
  return {
    {myVertices[1], myVertices[2], 0, 0, 255, 255, 255, 255},
    {myVertices[3], myVertices[4], 0, 1, 255, 255, 255, 255},
    {myVertices[5], myVertices[6], 1, 0, 255, 255, 255, 255}    
  }
end

function love.load()
  love.physics.setMeter(64)
  world = love.physics.newWorld(0, 9.81*64, true)
  
  mesh = love.graphics.newMesh(3, 'triangles', 'dynamic')
  mesh:setVertices(formatVertices(vertices))

  mesh:setTexture(love.graphics.newImage('assets/images/tex.png'))
  
  objects = {}
  objects.triangle = {}
  objects.triangle.body = love.physics.newBody(world, origin.x, origin.y, 'dynamic')
  objects.triangle.shape = love.physics.newPolygonShape(vertices)
  objects.triangle.fixture = love.physics.newFixture(objects.triangle.body, objects.triangle.shape, 1)
  objects.triangle.fixture:setRestitution(0.9)
  
  objects.ground = {}
  objects.ground.body = love.physics.newBody(world, love.graphics.getWidth()/2, love.graphics.getHeight()/1.2)
  objects.ground.shape = love.physics.newRectangleShape(650, 50)
  objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape)  
end

function love.update(dt)
  world:update(dt)
  objects.triangle.body:applyForce(0, 40)
  
--[[ 
Body:getWorldPoints returns 3 points(with x and y) - 6 return values. formatVertices requires a table, so you've got to have brackets around the method call
--]]
  mesh:setVertices(formatVertices({ objects.triangle.body:getWorldPoints(objects.triangle.shape:getPoints()) }))
end

function love.draw()
  love.graphics.draw(mesh, 0, 0)
  love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints()))
  --love.graphics.polygon("fill", objects.triangle.body:getWorldPoints(objects.triangle.shape:getPoints()))
end
